/* sumArea.cc */
/* $Lastupdate: 2007-11-07 20:19:29 $ */

/*

[ץ̾]

sumArea.cc ver. 3.1

[򤹤ץफ]

sumArea.cc ϡ

  node format V.0, 
  edge format V.0, V.1, V.2, V.4, 
  edge connection V.1, V.2, V.3, V.4, V.5

ǡåȤ˵ϿƤ륨åѤ¤򻻽ФɸϤ
񤭽ФץǤ

[Ȥ]

(1) ʤǵư :

% sumArea
# input file name
  expected data types are as follows:
  node format V.0
  edge format V.0, V.1, V.2, V.4
  edge connection V.1, V.2, V.3, V.4, V.5
: iFile

(2) Ĥǵư :

% sumArea iFile

  o iFile : node format V.0, 
            edge format V.0, V.1, V.2, V.4, 
            edge connection V.1, V.2, V.3, V.4, V.5 Τ줫(ϥե)

[ϥեΥեޥå]

node format V.0
edge format V.0
edge format V.1
edge format V.2
edge connection V.1
edge connection V.2
edge connection V.3

Τ줫

[ѥ]

% make

*/

#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <assert.h>
#include <stdlib.h>				// for getopt

#include "khboolean.h"
#include "khsimple.h"
#include "kherror.h"
#include "khstr.h"
#include "nopath.h"				// for nopath
#include "khdfstream.h"
  
void usage(const KhString& command)
{
  cerr
  << "\n" << command << " sums up area of edges.\n"
  << "usage: " << command << " [options] [iFile]\n"
  << "  options: \n"
  << "    -h  show this help message\n"
  << "    -v  show version number\n"
  << "  iFile : topographic data file name\n"
  << "  expected data formats are as follows:\n"
  << "  node format V.0, edge format V.0, V.1, V.2, V.4, \n"
  << "  edge connection V.1, V.2, V.3, V.4, V.5\n\n"
  << "  If \"iFile\" are given in the command line, \n"
  << "  the input data are read in from the file.\n"
  << "  Otherwise, the input data are read in from STDIN\n"
  << "  with giving prompting messages.\n" << endl;
  exit(1);
}

void version(void)
{
	cerr << "\nThis is sumArea, version 3.0\n"
		 << "developed by Yutaka ICHIKAWA, Kyoto Univ.\n" << endl;
}

int main
(
int argc,
char** argv
)
{

	KhString command = nopath(argv[0]);

  	// optstring ǡץȤƵʸꤷޤ
	char *optstring = "hv";

	int c;
	while((c = getopt(argc, argv, optstring)) != EOF)
	{
    	// getopt ϲϤץʸ֤ޤ
		switch (c) {
		  case 'v':
			version();
			exit(0);
		  case 'h':
			// ץʸ h ֤Ƥν
			// fall through
		  default:
			usage(command);
			exit(0);
		}
	}

	// argc ˤ, ޥ̾ȰθĿޤĤʤ
	// Ȥargc ˤ 1 ޤ

	if (argc != 1 && argc != 2)
	{
		//  command ǤϡθĿ1Ĥޤ0ĤǤ
		usage(command);
	}

	// ϥե̾
	char in[256];
	if (argc == 1)
	{
		cout << "# input file name\n"
			 << "  expected data types are as follows:\n"
			 << "  node format V.0\n"
			 << "  edge format V.0, V.1, V.2, V.4\n"
			 << "  edge connection V.1, V.2, V.3, V.4, V.5\n"
			 << ": " ;
		cin >> in;
	}
	else
	{
      //istrstream istri(argv[1]);
        istringstream istri((const char*)argv[1]);
		istri >> in;
	}

	KhDfstream iFile(in);
    if (!iFile)
    {
      cerr << "Can't open the file: " << in << endl;
      return 1;
    }

	KhString fmt, buf;

	// [Data Format Name] ǧ
//	while (getline(iFile, fmt) && fmt != "[Data Format Name]") ;
	while (getline(iFile, fmt) && 
 		   strncmp((const char *)fmt, "[Data Format Name]", 18) != 0) ;
	if (!getline(iFile, fmt))
	{
		iFile.close();
		char wbuf[20];
		cout << "Is this a node dataset or a edge dataset? [node/edge]: " ;
		cin >> wbuf ;

		KhDfstream iFile2(in);
		double totalArea = 0.0;

		while (getline(iFile2, buf))
		{
          //istrstream stbuf(buf);
            istringstream stbuf((const char*)buf);

			if (wbuf[0] == 'n' || wbuf[0] == 'N')
			{
				long i, j;
				stbuf >> i >> j ;

				// a == 1 : ή-ή襨å
				if (j == 1)
				{
					double x, y, z, area;
					stbuf >> x >> y >> z >> area ;
					totalArea += area;
				}
			}
			else if (wbuf[0] == 'e' || wbuf[0] == 'E')
			{
				long i, j, k, l;
				stbuf >> i >> j >> k >> l ;

				// a == 1 : ή-ή襨å
				if (l == 1)
				{
					double len, area;
					stbuf >> len >> area ;
					totalArea += area;
				}
			}
			else 
			{
				kherror();
				cerr << "Invalid answer: Type node or edge." << endl;
				abort();
			}
		}
		cout.precision(3);
		cout.setf(ios::fixed, ios::floatfield);
		cout << "total area: " << totalArea << " (m2)" << endl;
		return 0;
	}

	int dataType;
	if (strncmp((const char *)fmt, "node format V.0", 15) == 0)
		dataType = 0;
	else if (strncmp((const char *)fmt, "edge format V.0", 15) == 0)
		dataType = 1;
	else if (strncmp((const char *)fmt, "edge format V.1", 15) == 0)
		dataType = 2;
	else if (strncmp((const char *)fmt, "edge format V.2", 15) == 0)
		dataType = 3;
	else if (strncmp((const char *)fmt, "edge connection V.1", 19) == 0)
		dataType = 4;
	else if (strncmp((const char *)fmt, "edge connection V.2", 19) == 0)
		dataType = 5;
	else if (strncmp((const char *)fmt, "edge connection V.3", 19) == 0)
		dataType = 6;
	else if (strncmp((const char *)fmt, "edge format V.4", 15) == 0)
		dataType = 7;
	else if (strncmp((const char *)fmt, "edge connection V.4", 19) == 0)
		dataType = 8;
	else if (strncmp((const char *)fmt, "edge connection V.5", 19) == 0)
		dataType = 9;
	else
	{
		kherror();
		cerr << "Invalid dataset format" << "\n"
			 << "Expected data formats are as follows:\n"
			 << "node format V.0\n"
			 << "edge format V.0, V.1, V.2, V.4\n"
			 << "edge connection V.1, V.2, V.3, V.4, V.5" << endl;
		abort();
	}

	// [Data] ޤǿʤ
	while (getline(iFile, buf) && 
 		   strncmp((const char *)buf, "[Data]", 6) != 0) ;
	if (strncmp((const char *)buf, "[Data]", 6) != 0)
	{
		kherror();
		abort();
	}

	// եޥåȤ˱ƥǡɤ߼ꡢѤ­碌
	double totalArea = 0.0;
	double a, b;

	while (getline(iFile, buf))
	{
      //istrstream stbuf(buf);
        istringstream stbuf((const char*)buf);

		if (dataType == 0) // node format V.0
		{
			stbuf >> a >> a ;

			// a == 1 : ή-ή襨å
			if ((int)a == 1)
			{
				stbuf >> a >> a >> a >> a ;
				totalArea += a;
			}
		}
		if (dataType == 1) // edge format V.0
		{
			stbuf >> a >> a >> a >> a ;

			// a == 1 : ή-ή襨å
			if ((int)a == 1)
			{
				stbuf >> a >> a ;
				totalArea += a;
			}
		}
		else if (dataType == 2)	// edge format V.1
		{
			stbuf >> a >> a >> a >> a ;

			// a == 1 : ή-ή襨å
			if ((int)a == 1)
			{
				stbuf >> a >> a >> a ;
				totalArea += a;
			}
		}
		else if (dataType == 3)	// edge format V.2
		{
			stbuf >> a >> a >> a >> a >> a >> a >> a ;

			// a == 1 : ή-ή襨å
			if ((int)a == 1)
			{
				stbuf >> a >> a >> a ;
				totalArea += a;
			}
		}
		else if (dataType == 4) // edge connection V.1
		{
			// a: åֹ, b: ή¦åθĿ
			stbuf >> a >> b ;
			// a: ή¦åֹ
			for (int i = 0; i < (int)b; i++) stbuf >> a ;
			// b: ή¦åθĿ
			stbuf >> b ;
			// a: ή¦åֹ
			for (int i = 0; i < (int)b; i++) stbuf >> a ;

			// a == 1 : ή-ή襨å
			stbuf >> a ;
			if ((int)a == 1)
			{
				stbuf >> a >> a >> a ;
				totalArea += a;
			}
		}
		else if (dataType == 5 || dataType == 6) // edge connection V.2, V.3
		{
			// b: ή¦åθĿ
			stbuf >> a >> a >> a >> a >> b ;
			// a: ή¦åֹ
			for (int i = 0; i < (int)b; i++) stbuf >> a ;
			// b: ή¦åθĿ
			stbuf >> b ;
			// a: ή¦åֹ
			for (int i = 0; i < (int)b; i++) stbuf >> a ;
			// a: å°
			stbuf >> a ;
			// a == 1 : ή-ή襨å
			if ((int)a == 1)
			{
				stbuf >> a >> a >> a ;
				totalArea += a;
			}
		}
		else if (dataType == 7)	// edge format V.4
		{
			stbuf >> a					// åֹ
				  >> a >> a >> a >> a	// üΡֹȺɸ
				  >> a >> a >> a >> a	// üΡֹȺɸ
				  >> a ;				// å°

			// a == 1 : ή-ή襨å
			if ((int)a == 1)
			{
				stbuf >> a >> a >> a ;
				totalArea += a;
			}
		}
		else if (dataType == 8 || dataType == 9) // edge connection V.4, V.5
		{

			stbuf >> a					// åֹ
				  >> a >> a >> a >> a	// üΡֹȺɸ
				  >> a >> a >> a >> a	// üΡֹȺɸ
				  >> b ;				// ή¦åθĿ

			// a: ή¦åֹ
			for (int i = 0; i < (int)b; i++) stbuf >> a ;
			// b: ή¦åθĿ
			stbuf >> b ;
			// a: ή¦åֹ
			for (int i = 0; i < (int)b; i++) stbuf >> a ;
			// a: å°
			stbuf >> a ;
			// a == 1 : ή-ή襨å
			if ((int)a == 1)
			{
				stbuf >> a >> a >> a ;
				totalArea += a;
			}
		}
	}

	cout.precision(3);
	cout.setf(ios::fixed, ios::floatfield);
    cout << "total area: " << totalArea << " (m2)" << endl;

	return 0;
}
